diff -Naur test-for-latech/kernel/ecalls.c testqf-for-latech/kernel/ecalls.c
--- test-for-latech/kernel/ecalls.c	1969-12-31 19:00:00.000000000 -0500
+++ testqf-for-latech/kernel/ecalls.c	2004-06-11 07:47:23.000000000 -0400
@@ -0,0 +1,240 @@
+/*
+ *  linux/kernel/ecalls.c
+ *
+ *  Copyright (C) 1999/2000  Christian Poellabauer
+ */
+
+#include <linux/mm.h>
+#include <linux/utsname.h>
+#include <linux/mman.h>
+#include <linux/smp_lock.h>
+#include <linux/notifier.h>
+#include <linux/reboot.h>
+#include <linux/prctl.h>
+#include <linux/kernel.h>
+#include <linux/kmod.h>
+#include <linux/sched.h>
+
+#include <asm/uaccess.h>
+#include <asm/io.h>
+#include <asm/segment.h>
+#include <net/sock.h>
+#include <net/tcp.h>
+
+//#include <sys/syscall.h>
+#include <asm/unistd.h>
+
+#define MAX_LENGTH 32
+#define NR_THREADS 512
+
+extern void *sys_call_table[];
+#ifdef CONFIG_QFABRIC
+#ifdef CONFIG_X86
+#define __NR_SYSCALL_BASE 0
+extern void *fast_sys_call_table[];
+#endif
+#endif
+extern atomic_t access_lock;
+extern int sysctl_max_syn_backlog;
+
+struct ecall_down {
+	int shmid;	
+	void *shmaddr;
+};
+typedef struct ecall_down *t_downcall_data;
+
+struct ecall_up {
+	int shmid;	
+	void *shmaddr;
+};
+typedef struct ecall_up *t_upcall_data;
+
+/* Start ecall mechanism. */
+asmlinkage int sys_start_ecalls(void)
+{
+#ifdef CONFIG_QFABRIC
+	return request_module("ecalls");
+#endif
+	return 1;
+}
+
+/* End ecall mechanism. */
+asmlinkage int sys_end_ecalls(void)
+{
+	return 1;
+}
+
+/* Register ECall. */
+asmlinkage int sys_register_ecall(char *service, int len,
+	struct ecall_down *downcall, struct ecall_up *upcall)
+{
+        return -ENOSYS;
+}
+
+/* Do Downcall. */
+asmlinkage int sys_do_downcall(struct ecall_down *downcall, 
+	void *data, int len)
+{
+        return -ENOSYS;
+}
+
+/* Event handler function. */
+asmlinkage void sys_run_event_handler(void)
+{
+        return;
+}
+
+/* Fast event handler function. */
+asmlinkage int sys_fast_do_downcall(struct ecall_down *downcall,
+	void *data, int len)
+{
+        return -ENOSYS;
+}
+
+/* Call upcall scheduler. */
+asmlinkage int sys_upcall_scheduler(void) 
+{
+        return -ENOSYS;
+}
+
+/* Dummy sys_wake_up_ecalls. */
+asmlinkage int sys_wake_up_ecalls(void) 
+{
+        return -ENOSYS;
+}
+
+/* Dummy code download function. */
+asmlinkage int sys_download_code(void) 
+{
+        return -ENOSYS;
+}
+
+/* Set sock->readable or sock->writeable. */
+int set_sock_ecalls(struct socket *sock, int readable, int writable, int kecho,
+		    void *ptr, int fd, int pid) 
+{
+#ifdef CONFIG_QFABRIC
+	if (readable == 1) 
+		sock->sk->readable = 1;
+	else
+		sock->sk->readable = 0;
+	if (writable == 1)
+		sock->sk->writable = 1;
+	else
+		sock->sk->writable = 0;
+	if (kecho == 1)
+		sock->sk->kecho = 1;
+	else
+		sock->sk->kecho = 0;
+	sock->sk->kecho_ptr = ptr;
+	if (fd != -1)  
+	  sock->sk->fd = fd;
+	if (pid != -1)  
+	  sock->sk->owner = pid;
+#endif
+        return 0;
+}
+
+void call_event_handler(void) 
+{
+#ifdef CONFIG_QFABRIC
+  void (*ECalls_event_handler)(void);
+
+  ECalls_event_handler = sys_call_table[__NR_run_event_handler-__NR_SYSCALL_BASE];
+  ECalls_event_handler();
+#endif
+}
+
+void call_upcall_sched(struct task_struct **ts1, struct task_struct **ts2,
+	int *weight)
+{
+#ifdef CONFIG_QFABRIC
+  void (*upcall_sched)(struct task_struct **ts1, 
+		struct task_struct **ts2, int *weight);
+ 
+  upcall_sched = sys_call_table[__NR_upcall_scheduler-__NR_SYSCALL_BASE];
+  upcall_sched(ts1, ts2, weight);
+#endif
+}
+
+int call_admission_control(struct task_struct *ts1, struct sched_param *pa1)
+{
+#ifdef CONFIG_QFABRIC
+  int (*request_task_admission)(struct task_struct *ts1, 
+		struct sched_param *pa1);
+
+  request_task_admission = sys_call_table[__NR_admission_control-__NR_SYSCALL_BASE];
+  return (request_task_admission(ts1, pa1));
+#else
+  return -1;
+#endif
+}
+
+void call_update_util(int flag, struct task_struct *ts1)
+{
+#ifdef CONFIG_QFABRIC
+  void (*update_utilization)(int, struct task_struct *);
+  
+  update_utilization = sys_call_table[__NR_update_utilization-__NR_SYSCALL_BASE];
+  update_utilization(1, current);
+#endif
+}
+
+void call_wake_up(int i1, int i2, int i3, int i4, void *ptr)
+{
+#ifdef CONFIG_QFABRIC
+  void (*wake_up_using_ecalls)(int, int, int, int, void *);
+
+  wake_up_using_ecalls = sys_call_table[__NR_wake_up_ecalls-__NR_SYSCALL_BASE];
+  wake_up_using_ecalls(i1, i2, i3, i4, ptr);
+#endif
+}
+
+int get_sock_info(void *pointer, int flag)
+{
+#ifdef CONFIG_QFABRIC
+  struct sock *sk;
+
+  sk = (struct sock *) pointer;
+
+  if (flag == 0)
+    return sk->rcvbuf;
+  if (flag == 1)
+    return sk->rmem_alloc.counter;
+  if (flag == 2)
+    return sk->receive_queue.qlen;
+  if (flag == 3)
+    return sk->ack_backlog;
+  if (flag == 4)
+    return sysctl_max_syn_backlog;
+  if (flag == 5)
+    return tcp_synq_is_full(sk);
+  if (flag == 6)
+    return sk->socket->state;
+  if (flag == 7)
+    return sk->counter;
+  if (flag == 8)
+    return sk->rmem_alloc.counter;
+  if (flag == 9)
+    return sk->wmem_alloc.counter;
+#endif
+  return -1;
+}
+
+int set_sock_info(void *pointer, int flag, int value)
+{
+#ifdef CONFIG_QFABRIC
+  struct sock *sk;
+
+  sk = (struct sock *) pointer;
+
+  if (flag == 0)
+    sk->rcvbuf = value;
+  if (flag == 3)
+    sk->max_ack_backlog = value;
+  if (flag == 4)
+    sysctl_max_syn_backlog = value;
+  return 0;
+#endif
+  return -1;
+}
diff -Naur test-for-latech/kernel/exit.c testqf-for-latech/kernel/exit.c
--- test-for-latech/kernel/exit.c	2004-06-11 07:40:02.000000000 -0400
+++ testqf-for-latech/kernel/exit.c	2004-06-11 07:47:23.000000000 -0400
@@ -5,6 +5,9 @@
  */
 
 #include <linux/config.h>
+#ifdef CONFIG_QFABRIC
+#include <linux/init.h>
+#endif
 #include <linux/slab.h>
 #include <linux/interrupt.h>
 #include <linux/smp_lock.h>
@@ -23,10 +26,19 @@
 
 extern void sem_exit (void);
 extern struct task_struct *child_reaper;
+#ifdef CONFIG_DWCS
+#include <linux/unistd.h>
+extern void *sys_call_table[];
+extern int DWCS_module_loaded;
+#endif
 
 int getrusage(struct task_struct *, int, struct rusage *);
 
+#ifdef CONFIG_QFABRIC
+void release_task(struct task_struct * p)
+#else
 static void release_task(struct task_struct * p)
+#endif
 {
 	if (p != current) {
 #ifdef CONFIG_SMP
@@ -449,6 +461,23 @@
 	tsk->flags |= PF_EXITING;
 	del_timer_sync(&tsk->real_timer);
 
+	/* 
+	 * Set flag for computation of utilization.
+	 */
+#ifdef CONFIG_DWCS
+	if (DWCS_module_loaded) {
+	  void (*update_utilization)(int, struct task_struct *);
+	  update_utilization = sys_call_table[__NR_update_utilization-__NR_SYSCALL_BASE];
+	  update_utilization(1, current);
+	}
+#endif
+#ifdef CONFIG_QFABRIC
+	if (tsk->qfabric != NULL) {
+	  kfree(tsk->qfabric->fdqfabric);
+	  kfree(tsk->qfabric);
+	}
+#endif
+
 fake_volatile:
 #ifdef CONFIG_BSD_PROCESS_ACCT
 	acct_process(code);
diff -Naur test-for-latech/kernel/fork.c testqf-for-latech/kernel/fork.c
--- test-for-latech/kernel/fork.c	2004-06-11 07:40:02.000000000 -0400
+++ testqf-for-latech/kernel/fork.c	2004-06-11 07:47:23.000000000 -0400
@@ -690,9 +690,46 @@
 		goto bad_fork_cleanup_sighand;
 	if (copy_namespace(clone_flags, p))
 		goto bad_fork_cleanup_mm;
+
+#ifdef CONFIG_DWCS
+	/* --RW--
+	 * Initialize the dwcs_params structure, in case the DWCS
+	 * scheduler is in operation.
+	 */
+	p->dwcs_params = kmalloc(sizeof(struct dwcs_struct), GFP_ATOMIC);
+	if (!p->dwcs_params) {
+	  retval = -ENOMEM;
+	  goto bad_fork_cleanup_namespace;
+	}
+	
+	p->dwcs_params->cd            = p->pid;
+	/* Default = no deadline */
+	p->dwcs_params->deadline      = (unsigned long) -1; 
+	p->dwcs_params->period        = (unsigned long) -1; 
+	/* `period' is a multiple of jiffies. */
+	p->dwcs_params->own           = 1;
+	p->dwcs_params->owd           = 10;
+	p->dwcs_params->cwn           = 1;
+	p->dwcs_params->cwd           = 10;
+	p->dwcs_params->flags         = DWCS_WORK_CONS;
+	p->dwcs_params->ready_time    = 0;
+	p->dwcs_params->service_time  = 1; /* x 10mS for each clock tick. */
+	p->dwcs_params->time_serviced = 0;
+	p->dwcs_params->wlate         = 0;
+	p->dwcs_params->late          = 0;
+	p->dwcs_params->on_time       = 0;
+	p->dwcs_params->violations    = 0;
+	/* End of --RW-- */
+#endif
+
+
 	retval = copy_thread(0, clone_flags, stack_start, stack_size, p, regs);
 	if (retval)
+#ifdef CONFIG_DWCS
+	  	goto bad_fork_cleanup_dwcs;
+#else
 		goto bad_fork_cleanup_namespace;
+#endif
 	p->semundo = NULL;
 	
 	/* Our parent execution domain becomes current domain
@@ -700,6 +737,15 @@
 	   
 	p->parent_exec_id = p->self_exec_id;
 
+#ifdef CONFIG_QFABRIC
+	p->qfabric = NULL;
+        p->kthread = 0;
+        p->suser_flag = 0;
+        p->uaccess_flag = 0;
+        p->ecalls_flag = 0;
+        p->syscall_counter = 0;
+#endif
+
 	/* ok, now we should be set up.. */
 	p->swappable = 1;
 	p->exit_signal = clone_flags & CSIGNAL;
@@ -758,7 +804,10 @@
 
 fork_out:
 	return retval;
-
+#ifdef CONFIG_DWCS
+bad_fork_cleanup_dwcs:
+       kfree(p->dwcs_params);
+#endif
 bad_fork_cleanup_namespace:
 	exit_namespace(p);
 bad_fork_cleanup_mm:
diff -Naur test-for-latech/kernel/ksyms.c testqf-for-latech/kernel/ksyms.c
--- test-for-latech/kernel/ksyms.c	2004-06-11 07:40:02.000000000 -0400
+++ testqf-for-latech/kernel/ksyms.c	2004-06-11 07:47:23.000000000 -0400
@@ -39,6 +39,12 @@
 #include <linux/poll.h>
 #include <linux/mmzone.h>
 #include <linux/mm.h>
+#ifdef CONFIG_QFABRIC
+#include <linux/shm.h>
+#include <linux/socket.h>
+#include <linux/net.h>
+#include <linux/sched.h>
+#endif
 #include <linux/capability.h>
 #include <linux/highuid.h>
 #include <linux/brlock.h>
@@ -47,6 +53,11 @@
 #include <linux/in6.h>
 #include <linux/completion.h>
 #include <linux/seq_file.h>
+#ifdef CONFIG_QFABRIC
+#include <net/sock.h>
+#include <asm/current.h>
+#include <asm/uaccess.h>
+#endif
 #include <asm/checksum.h>
 
 #if defined(CONFIG_PROC_FS)
@@ -56,9 +67,57 @@
 #include <linux/kmod.h>
 #endif
 
+//#define DWCS_DEBUG_ON 1
+
+#ifdef CONFIG_QFABRIC
+#define NR_THREADS 512
+ 
+extern int get_pseudofd(struct socket *sock, struct socket *fd_array[]);
+extern int release_pseudofd(int fd, struct socket *fd_array[]);
+extern struct socket *look_up_pseudofd(int fd, struct socket *fd_array[]);
+extern int poll_socket(struct socket *socket);
+extern int sys_recvmsg(int fd, struct msghdr *msg, unsigned int flags);
+extern long sys_sched_yield(void);
+extern void initialize_qfabric(void);
+extern int ECalls_active;
+#endif
+
+#ifdef CONFIG_DWCS
+extern int DWCS_module_loaded;	        /* --RW-- */
+extern void (*DWCS_scheduler)(struct task_struct **, struct task_struct **);    /* --FS-- */
+extern struct list_head runqueue_head;  /* --FS-- */
+extern int DWCS_admission_control;      /* --CP-- */
+extern int DWCS_update_utilization;	/* --CP-- */
+extern int utilization;			/* --CP-- */
+#ifdef DWCS_DEBUG_ON
+extern unsigned long dwcs_timer_max_time;
+extern long dwcs_max_counter;
+extern long dwcs_pid;
+extern unsigned long dwcs_sched_max_time;
+#endif
+#endif
+#ifdef CONFIG_QFABRIC
+extern int security_off;		/* --CP-- */
+extern int SOCKWATCH_module_loaded;     /* --CP-- */
+extern int set_sock_ecalls(struct socket *, int, int, int, void*); /* --CP-- */
+extern int get_sock_info(void *, int);  /* --CP-- */
+extern int set_sock_info(void *, int, int); /* --CP-- */
+extern int wake_up_process(struct task_struct * tsk);
+extern struct socket *sockfd_lookup(int fd, int *err);
+extern unsigned long total_forks;
+extern struct page *grab_cache_page_ex(struct address_space *mapping, 
+		unsigned long index, struct page **cached_page);
+#endif
+extern unsigned long volatile jiffies_sim; 
+
 extern void set_device_ro(kdev_t dev,int flag);
 
 extern void *sys_call_table;
+#ifdef CONFIG_QFABRIC
+#ifdef CONFIG_X86
+extern void *fast_sys_call_table;
+#endif
+#endif
 
 extern struct timezone sys_tz;
 extern int request_dma(unsigned int dmanr, char * deviceID);
@@ -80,6 +139,33 @@
 EXPORT_SYMBOL(inter_module_put);
 EXPORT_SYMBOL(try_inc_mod_count);
 
+/* --RW--
+ * Dionisys and DWCS module symbols.
+ */
+#ifdef CONFIG_DWCS
+EXPORT_SYMBOL(DWCS_module_loaded);
+EXPORT_SYMBOL(DWCS_scheduler);  /* --FS-- */
+EXPORT_SYMBOL(init_tasks);  /* --CP-- */
+#ifdef DWCS_DEBUG_ON
+EXPORT_SYMBOL(dwcs_timer_max_time);
+EXPORT_SYMBOL(dwcs_max_counter);
+EXPORT_SYMBOL(dwcs_pid);
+EXPORT_SYMBOL(dwcs_sched_max_time);
+#endif
+
+/*
+EXPORT_SYMBOL(do_bottom_half);
+*/
+EXPORT_SYMBOL(jiffies_sim);
+/*
+ * GANEV: exported various symbols so that they would be accessible to
+ *        loadable kernel schedulers like DWCS.
+ */
+EXPORT_SYMBOL(aligned_data);
+EXPORT_SYMBOL(runqueue_head);	/* --FS-- */
+EXPORT_SYMBOL(runqueue_lock);
+#endif
+
 /* process memory management */
 EXPORT_SYMBOL(do_mmap_pgoff);
 EXPORT_SYMBOL(do_munmap);
@@ -394,6 +480,9 @@
 #ifdef CONFIG_SMP
 /* Various random spinlocks we want to export */
 EXPORT_SYMBOL(tqueue_lock);
+#ifdef CONFIG_DWCS
+EXPORT_SYMBOL(global_irq_lock);		/* --RW-- */
+#endif
 
 /* Big-Reader lock implementation */
 EXPORT_SYMBOL(__brlock_array);
@@ -440,7 +529,6 @@
 EXPORT_SYMBOL(complete_and_exit);
 EXPORT_SYMBOL(__wake_up);
 EXPORT_SYMBOL(__wake_up_sync);
-EXPORT_SYMBOL(wake_up_process);
 EXPORT_SYMBOL(sleep_on);
 EXPORT_SYMBOL(sleep_on_timeout);
 EXPORT_SYMBOL(interruptible_sleep_on);
@@ -480,6 +568,11 @@
 #ifndef __mips__
 EXPORT_SYMBOL(sys_call_table);
 #endif
+#ifdef CONFIG_QFABRIC
+#ifdef CONFIG_X86
+EXPORT_SYMBOL(fast_sys_call_table);
+#endif
+#endif
 EXPORT_SYMBOL(machine_restart);
 EXPORT_SYMBOL(machine_halt);
 EXPORT_SYMBOL(machine_power_off);
@@ -570,3 +663,43 @@
 
 EXPORT_SYMBOL(tasklist_lock);
 EXPORT_SYMBOL(pidhash);
+
+/* --CP-- */
+#ifdef CONFIG_QFABRIC
+EXPORT_SYMBOL(get_pseudofd);
+EXPORT_SYMBOL(release_pseudofd);
+EXPORT_SYMBOL(look_up_pseudofd);
+EXPORT_SYMBOL(poll_socket);
+EXPORT_SYMBOL(sys_shmat);
+EXPORT_SYMBOL(sys_recvmsg);
+EXPORT_SYMBOL(upcall_sched_active);
+#endif
+#ifdef CONFIG_DWCS
+EXPORT_SYMBOL(DWCS_update_utilization);
+EXPORT_SYMBOL(DWCS_admission_control);
+EXPORT_SYMBOL(utilization);
+#endif
+#ifdef CONFIG_QFABRIC
+EXPORT_SYMBOL(security_off);
+EXPORT_SYMBOL(ECalls_current_flag);
+EXPORT_SYMBOL(ECalls_current);
+EXPORT_SYMBOL(global_wait_queue);
+//EXPORT_SYMBOL(sys_sched_yield);
+EXPORT_SYMBOL(SOCKWATCH_module_loaded);
+EXPORT_SYMBOL(set_sock_ecalls);
+EXPORT_SYMBOL(get_sock_info);
+EXPORT_SYMBOL(set_sock_info);
+EXPORT_SYMBOL(sockfd_lookup);
+EXPORT_SYMBOL(initialize_qfabric);
+EXPORT_SYMBOL(ECalls_active);
+EXPORT_SYMBOL(avenrun);
+EXPORT_SYMBOL(nr_free_pages);
+EXPORT_SYMBOL(swapper_space);
+EXPORT_SYMBOL(si_swapinfo);
+EXPORT_SYMBOL(page_cache_size);
+EXPORT_SYMBOL(nr_inactive_pages);
+EXPORT_SYMBOL(nr_active_pages);
+EXPORT_SYMBOL(total_forks);
+EXPORT_SYMBOL(grab_cache_page_ex);
+#endif
+EXPORT_SYMBOL(wake_up_process);
diff -Naur test-for-latech/kernel/Makefile testqf-for-latech/kernel/Makefile
--- test-for-latech/kernel/Makefile	2004-06-11 07:40:02.000000000 -0400
+++ testqf-for-latech/kernel/Makefile	2004-06-11 07:47:23.000000000 -0400
@@ -14,12 +14,16 @@
 obj-y     = sched.o dma.o fork.o exec_domain.o panic.o printk.o \
 	    module.o exit.o itimer.o info.o time.o softirq.o resource.o \
 	    sysctl.o acct.o capability.o ptrace.o timer.o user.o \
-	    signal.o sys.o kmod.o context.o
+	    signal.o sys.o kmod.o context.o ecalls.o qfabric.o
 
 obj-$(CONFIG_UID16) += uid16.o
 obj-$(CONFIG_MODULES) += ksyms.o
 obj-$(CONFIG_PM) += pm.o
 
+ifeq ($(CONFIG_DWCS),y)
+obj-m += dwcs.o
+endif
+
 ifneq ($(CONFIG_IA64),y)
 # According to Alan Modra <alan@linuxcare.com.au>, the -fno-omit-frame-pointer is
 # needed for x86 only.  Why this used to be enabled for all architectures is beyond
diff -Naur test-for-latech/kernel/qfabric.c testqf-for-latech/kernel/qfabric.c
--- test-for-latech/kernel/qfabric.c	1969-12-31 19:00:00.000000000 -0500
+++ testqf-for-latech/kernel/qfabric.c	2004-06-11 07:47:23.000000000 -0400
@@ -0,0 +1,190 @@
+/*
+ *  linux/kernel/qfabric.c
+ *
+ *  Copyright (C) 1999/2000  Christian Poellabauer
+ */
+
+#include <linux/mm.h>
+#include <linux/utsname.h>
+#include <linux/mman.h>
+#include <linux/smp_lock.h>
+#include <linux/notifier.h>
+#include <linux/reboot.h>
+#include <linux/prctl.h>
+#include <linux/kernel.h>
+#include <linux/kmod.h>
+#include <linux/sched.h>
+#include <linux/socket.h>
+#include <linux/skbuff.h>
+#include <net/sock.h>
+
+#include <asm/uaccess.h>
+#include <asm/io.h>
+#include <asm/segment.h>
+#include <asm/unistd.h>
+
+//#include <sys/syscall.h>
+
+#define MAX_LENGTH 32
+#define NR_THREADS 512
+
+extern void *sys_call_table[];
+extern atomic_t access_lock;
+
+/* Load Kernel ECho modules. */
+asmlinkage int sys_kecho_load(char * module_name, int argument)
+{
+        char k_module_name[MAX_LENGTH];
+
+        /* Copy argument into kernel space. */
+        copy_from_user(k_module_name, module_name, MAX_LENGTH);
+
+        /* Load requested module. */
+        return request_module(k_module_name);
+}
+
+#ifdef CONFIG_QFABRIC
+/* Look up pseudo fd number. */
+struct socket *look_up_pseudofd(int fd, struct socket *fd_array[])
+{
+	return fd_array[fd];
+}
+
+/* Get pseudofd */
+int get_pseudofd(struct socket *sock, struct socket *fd_array[]) 
+{
+	int i = 0;
+
+	while ((i < MAX_FDS) && (fd_array[i] != NULL)) i++;
+
+        if (i == MAX_FDS) return -1;
+
+       	fd_array[i] = sock;
+
+      	return i;
+}
+
+/* Release pseudo fd. */
+int release_pseudofd(int i, struct socket *fd_array[]) 
+{
+       	fd_array[i] = NULL;
+
+ 	return 0;
+}
+
+/* Poll socket for incoming data. */
+int poll_socket(struct socket *socket) 
+{
+	struct sock *sock;
+
+    	sock = socket->sk;
+	if ((sock == NULL) || (sock->receive_queue.next == NULL) ||
+         (sock->receive_queue.next->len <= 0) ||
+         (sock->receive_queue.next->len > sock->receive_queue.next->truesize))
+     		return 0;
+	else	
+		return 1;
+}
+
+extern mm_segment_t kernel_get_fs(void)
+{
+	return current->addr_limit;
+}
+
+#ifdef CONFIG_X86_WP_WORKS_OK
+
+extern int kernel_access_ok(int type, const void *addr, size_t size) 
+{
+	if (__range_ok(addr,size) == 0) 
+		return 1;
+	return 0;
+}
+
+#else
+#ifdef CONFIG_ARM
+extern int kernel_access_ok(int type, const void *addr, size_t size) 
+{
+	if (__range_ok(addr,size) == 0) 
+		return 1;
+	return 0;
+}
+#else
+#ifndef CONFIG_IA64
+extern int kernel_access_ok(int type, const void *addr, size_t size)
+{
+ 	if ((__range_ok(addr,size) == 0) && 
+		 ((type) == VERIFY_READ || boot_cpu_data.wp_works_ok || 
+			 segment_eq(get_fs(),KERNEL_DS) || 
+			  __verify_write((void *)(addr),(size))))
+		return 1;
+	return 0;
+}
+#endif
+#endif
+#endif /* CPU */
+
+/* Initialize qfabric data structure. */
+void initialize_qfabric(void)
+{
+	if (current->qfabric == NULL) {
+ 		current->qfabric = (struct qfabric_struct *)
+		  kmalloc(sizeof(struct qfabric_struct), GFP_KERNEL); 
+		current->qfabric->fdqfabric = kmalloc (MAX_FDS, GFP_KERNEL);
+		memset(current->qfabric->fdqfabric, 0, MAX_FDS);
+		init_waitqueue_head(&current->qfabric->kecho_queue);
+		current->qfabric->weight = 0;
+		current->qfabric->orig_weight = 0;
+		current->qfabric->sw_pending = 0;
+	}
+}
+#endif
+/* KECho System Call API:  */
+asmlinkage int sys_KECho_syscall_echo(void *echo_data) 
+{
+        return -ENOSYS;
+}
+
+asmlinkage int sys_fast_KECho_syscall_echo(void *echo_data) 
+{
+        return -ENOSYS;
+}
+
+asmlinkage int sys_KECho_syscall_cm(void *cm_data) 
+{
+        return -ENOSYS;
+}
+
+asmlinkage int sys_fast_KECho_syscall_cm(void *cm_data) 
+{
+        return -ENOSYS;
+}
+
+asmlinkage int sys_KECho_syscall_cg(void *cg_data) 
+{
+        return -ENOSYS;
+}
+
+asmlinkage int sys_fast_KECho_syscall_cg(void *cg_data) 
+{
+        return -ENOSYS;
+}
+
+asmlinkage int sys_KECho_syscall_atl(void *atl_data) 
+{
+        return -ENOSYS;
+}
+
+asmlinkage int sys_fast_KECho_syscall_atl(void *atl_data) 
+{
+        return -ENOSYS;
+}
+
+asmlinkage int sys_KECho_sw_callback(int fd, int pid, void *ptr) 
+{
+        return -ENOSYS;
+}
+
+asmlinkage int sys_qos_configure(void)
+{
+        return -ENOSYS;
+}
diff -Naur test-for-latech/kernel/sched.c testqf-for-latech/kernel/sched.c
--- test-for-latech/kernel/sched.c	2004-06-11 07:40:02.000000000 -0400
+++ testqf-for-latech/kernel/sched.c	2004-06-11 07:47:23.000000000 -0400
@@ -33,6 +33,20 @@
 #include <asm/uaccess.h>
 #include <asm/mmu_context.h>
 
+//#define DWCS_DEBUG_ON 1
+
+#ifdef CONFIG_DWCS
+#include <linux/sched.h>
+#include <asm/unistd.h>
+#endif
+
+#ifdef CONFIG_QFABRIC
+extern void call_event_handler(void);
+extern void call_upcall_sched(struct task_struct **,
+	struct task_struct **, int *);
+extern int call_admission_control(struct task_struct *, struct sched_param *);
+#endif
+
 extern void timer_bh(void);
 extern void tqueue_bh(void);
 extern void immediate_bh(void);
@@ -41,10 +55,21 @@
  * scheduler variables
  */
 
+#ifdef CONFIG_QFABRIC
+atomic_t access_lock;
+atomic_t access_lock2;
+struct socket *fd_array[MAX_FDS];
+int ECalls_active = 0;
+
+struct wait_queue *global_wait_queue = NULL;
+#endif
+
 unsigned securebits = SECUREBITS_DEFAULT; /* systemwide security settings */
 
 extern void mem_use(void);
 
+unsigned long volatile jiffies_sim = 0; /* --RW-- */
+
 /*
  * Scheduling quanta.
  *
@@ -70,6 +95,31 @@
 
 #define NICE_TO_TICKS(nice)	(TICK_SCALE(20-(nice))+1)
 
+#ifdef CONFIG_DWCS
+#define MAX_TASKS 128
+/* 
+ * Module variables for DWCS scheduling and ECalls.
+ */
+#ifdef DWCS_DEBUG_ON
+unsigned long dwcs_sched_max_time = 0;
+unsigned long dwcs_old_time = 0;
+long dwcs_pid = -2;
+#endif
+int DWCS_module_loaded = 0;	/* Not initially loaded. */
+void (*DWCS_scheduler)(struct task_struct **, struct task_struct **) = NULL;
+int DWCS_update_utilization = 1;/* Initially set. */
+int utilization = 0;
+int DWCS_admission_control = 0; /* Not initially active. */
+#endif
+#ifdef CONFIG_QFABRIC
+int upcall_sched_active = 0;    /* Not initially active. */
+int security_off = 0;	        /* Not initially active. */
+int ECalls_current_flag = 0;    /* Not initially set. */
+struct task_struct *ECalls_current;
+int SOCKWATCH_module_loaded = 0;
+
+#endif
+extern void *sys_call_table[];
 
 /*
  *	Init task must be ok at boot for the ix86 as we will check its signals
@@ -92,19 +142,27 @@
 spinlock_t runqueue_lock __cacheline_aligned = SPIN_LOCK_UNLOCKED;  /* inner */
 rwlock_t tasklist_lock __cacheline_aligned = RW_LOCK_UNLOCKED;	/* outer */
 
-static LIST_HEAD(runqueue_head);
+LIST_HEAD(runqueue_head);
 
 /*
  * We align per-CPU scheduling data on cacheline boundaries,
  * to prevent cacheline ping-pong.
+ *
+ * GANEV: moved the data type description into a "typedef" in <linux/sched.h>
+ *        to make it accessible from a separately compiled loadable kernel
+ *        module.
  */
+#ifdef CONFIG_DWCS
+aligned_data_t aligned_data[NR_CPUS] __cacheline_aligned = { {{&init_task,0}}};
+#else
 static union {
 	struct schedule_data {
-		struct task_struct * curr;
+		struct task_struct *curr;
 		cycles_t last_schedule;
 	} schedule_data;
 	char __pad [SMP_CACHE_BYTES];
-} aligned_data [NR_CPUS] __cacheline_aligned = { {{&init_task,0}}};
+} aligned_data [NR_CPUS] __cacheline_aligned = { {{&init_task, 0}}};
+#endif
 
 #define cpu_curr(cpu) aligned_data[(cpu)].schedule_data.curr
 #define last_schedule(cpu) aligned_data[(cpu)].schedule_data.last_schedule
@@ -189,6 +247,15 @@
 	 * into account).
 	 */
 	weight = 1000 + p->rt_priority;
+#ifdef CONFIG_QFABRIC
+	if (p->qfabric != NULL) {
+	  if (p->qfabric->weight > 0) {
+	    weight  = -1000;
+	    p->qfabric->weight--;
+	  } else
+	    p->qfabric->weight = p->qfabric->orig_weight;
+	}
+#endif
 out:
 	return weight;
 }
@@ -536,6 +603,97 @@
 	__schedule_tail(prev);
 }
 
+/* --RW-- */
+#ifdef CONFIG_DWCS
+void dwcs_switch (struct task_struct *prev, struct task_struct *next) {
+
+  /* GANEV/FS: added definitions for "sched_data" which is needed in the
+   *           conditional below. */
+  int this_cpu;
+#ifdef CONFIG_SMP
+  struct schedule_data * sched_data;
+#endif
+  
+  this_cpu = prev->processor;
+
+  /* We might have switched CPUs: */
+#ifdef CONFIG_SMP
+  sched_data = & aligned_data[this_cpu].schedule_data;
+#endif
+
+
+	if (unlikely(prev == next)) {
+		/* We won't go through the normal tail, so do this by hand */
+		prev->policy &= ~SCHED_YIELD;
+		goto same_process;
+	}
+
+#ifdef CONFIG_SMP
+ 	/*
+ 	 * maintain the per-process 'last schedule' value.
+ 	 * (this has to be recalculated even if we reschedule to
+ 	 * the same process) Currently this is only used on SMP,
+	 * and it's approximate, so we do not have to maintain
+	 * it while holding the runqueue spinlock.
+ 	 */
+ 	sched_data->last_schedule = get_cycles();
+
+	/*
+	 * We drop the scheduler lock early (it's a global spinlock),
+	 * thus we have to lock the previous process from getting
+	 * rescheduled during switch_to().
+	 */
+
+#endif /* CONFIG_SMP */
+
+	kstat.context_swtch++;
+	/*
+	 * there are 3 processes which are affected by a context switch:
+	 *
+	 * prev == .... ==> (last => next)
+	 *
+	 * It's the 'much more previous' 'prev' that is on next's stack,
+	 * but prev is set to (the just run) 'last' process by switch_to().
+	 * This might sound slightly confusing but makes tons of sense.
+	 */
+	prepare_to_switch();
+	{
+		struct mm_struct *mm = next->mm;
+		struct mm_struct *oldmm = prev->active_mm;
+		if (!mm) {
+			BUG_ON(next->active_mm);
+			next->active_mm = oldmm;
+			atomic_inc(&oldmm->mm_count);
+			enter_lazy_tlb(oldmm, next, this_cpu);
+		} else {
+			BUG_ON(next->active_mm != mm);
+			switch_mm(oldmm, mm, next, this_cpu);
+		}
+
+		if (!prev->mm) {
+			prev->active_mm = NULL;
+			mmdrop(oldmm);
+		}
+	}
+
+	/*
+	 * This just switches the register state and the
+	 * stack.
+	 */
+	switch_to(prev, next, prev);
+	__schedule_tail(prev);
+
+same_process:
+	reacquire_kernel_lock(current);
+	/* --FS-- this check is moved to kernel/dwcs.c:schedule()
+	* if (current->need_resched)
+	*	goto need_resched_back;
+	*/
+	return;
+}  
+#endif
+
+
 /*
  *  'schedule()' is the scheduler function. It's a very simple and nice
  * scheduler: it's not perfect, but certainly works for most things.
@@ -550,10 +708,56 @@
 {
 	struct schedule_data * sched_data;
 	struct task_struct *prev, *next, *p;
+#ifdef CONFIG_QFABRIC
+	struct task_struct *old_p;
+#endif
 	struct list_head *tmp;
 	int this_cpu, c;
 
+#ifdef DWCS_DEBUG_ON
+	if (dwcs_old_time == 0) {
+		dwcs_old_time = jiffies;
+	} else {
+		unsigned long tmp;
+		tmp = jiffies - dwcs_old_time;
+		dwcs_old_time = jiffies;
+		if (dwcs_sched_max_time < tmp) {
+			dwcs_sched_max_time = tmp;
+			dwcs_pid = current->pid;
+		}
+	}
+#endif
 
+	/*
+	 * POELLABAUER: check if the current process created any
+	 * events via ECalls and if so process them.
+	 */
+#ifdef CONFIG_QFABRIC
+	if ((ECalls_active > 0) && (current->ecalls_flag))
+		call_event_handler();
+#endif
+
+  	/* --RW--
+         * First, check to see if the DWCS module is loaded.
+         * If so, call the DWCS scheduler instead.
+         */
+  	
+  	/*
+ 	 * GANEV: modified the scheduler function pointer to accept
+  	 *        two "struct task_struct *" parameters for the automatic
+  	 *        "prev" and "nexxt" variables, and pass back the chosen
+  	 *        task to run in them. Global variables to do this work no
+  	 *        longer if we want to be SMP-safe...
+  	 */
+
+#ifdef CONFIG_DWCS	
+  	if (DWCS_module_loaded && DWCS_scheduler) {
+  	  DWCS_scheduler(&prev, &next);
+  	  dwcs_switch(prev,next);
+  	  return;
+  	}
+#endif
+  	
 	spin_lock_prefetch(&runqueue_lock);
 
 	BUG_ON(!current->active_mm);
@@ -614,6 +818,16 @@
 		}
 	}
 
+        /* --CP-- */
+#ifdef CONFIG_DWCS
+#ifdef CONFIG_QFABRIC
+  	if (upcall_sched_active) {
+	  old_p = next;
+	  call_upcall_sched(&old_p, &next, &c);
+	}
+#endif
+#endif
+
 	/* Do we need to re-calculate counters? */
 	if (unlikely(!c)) {
 		struct task_struct *p;
@@ -930,10 +1144,10 @@
 	else {
 		retval = -EINVAL;
 		if (policy != SCHED_FIFO && policy != SCHED_RR &&
-				policy != SCHED_OTHER)
-			goto out_unlock;
+		    policy != SCHED_OTHER)
+		  goto out_unlock;
 	}
-	
+
 	/*
 	 * Valid priorities for SCHED_FIFO and SCHED_RR are 1..99, valid
 	 * priority for SCHED_OTHER is 0.
diff -Naur test-for-latech/kernel/signal.c testqf-for-latech/kernel/signal.c
--- test-for-latech/kernel/signal.c	2004-06-11 07:40:02.000000000 -0400
+++ testqf-for-latech/kernel/signal.c	2004-06-11 07:47:23.000000000 -0400
@@ -52,7 +52,7 @@
 {
 	unsigned long i, *s, *m, x;
 	int sig = 0;
-	
+
 	s = tsk->pending.signal.sig;
 	m = mask->sig;
 	switch (_NSIG_WORDS) {
@@ -64,6 +64,22 @@
 			}
 		break;
 
+#ifdef CONFIG_QFABRIC
+	case 2: if (test_bit(SIGSTOP, &s[0]) == 1)
+			sig = SIGSTOP;
+		else if (test_bit(SIGKILL, &s[0]) == 1)
+			sig = SIGKILL;
+		else {
+			if ((x = s[1] &~ m[1]) != 0)
+				sig = _NSIG_BPW + 1;
+			else if ((x = s[0] &~ m[0]) != 0)
+				sig = 1;
+			else
+				break;
+			sig += ffz(~x);
+			break;
+		}
+#else
 	case 2: if ((x = s[0] &~ m[0]) != 0)
 			sig = 1;
 		else if ((x = s[1] &~ m[1]) != 0)
@@ -72,6 +88,7 @@
 			break;
 		sig += ffz(~x);
 		break;
+#endif
 
 	case 1: if ((x = *s &~ *m) != 0)
 			sig = ffz(~x) + 1;
diff -Naur test-for-latech/kernel/sys.c testqf-for-latech/kernel/sys.c
--- test-for-latech/kernel/sys.c	2004-06-11 07:40:02.000000000 -0400
+++ testqf-for-latech/kernel/sys.c	2004-06-11 07:47:23.000000000 -0400
@@ -1279,6 +1279,47 @@
 	return error;
 }
 
+/* --RW-- 
+ * Replace this with the proper scheduler, when the 
+ * corresponding module is loaded. 
+ */
+asmlinkage void sys_load_scheduler (void)
+{
+ 	return;
+}
+ 
+asmlinkage void sys_unload_scheduler (void)
+{
+	return;
+}
+ 
+asmlinkage void sys_DWCS_scheduler (void)
+{
+	return;
+}
+
+asmlinkage void sys_update_utilization (void)
+{
+	return;
+}
+
+asmlinkage void sys_admission_control (void)
+{
+	return;
+}
+
+asmlinkage long sys_getsyscalls (void)
+{
+#ifdef CONFIG_QFABRIC
+	return current->syscall_counter;
+#endif
+}
+
+asmlinkage void sys_change_clock (void)
+{
+	return;
+}
+
 EXPORT_SYMBOL(notifier_chain_register);
 EXPORT_SYMBOL(notifier_chain_unregister);
 EXPORT_SYMBOL(notifier_call_chain);
diff -Naur test-for-latech/kernel/timer.c testqf-for-latech/kernel/timer.c
--- test-for-latech/kernel/timer.c	2004-06-11 07:40:02.000000000 -0400
+++ testqf-for-latech/kernel/timer.c	2004-06-11 07:47:23.000000000 -0400
@@ -25,6 +25,12 @@
 
 #include <asm/uaccess.h>
 
+//#define DWCS_DEBUG_ON 1
+
+#ifdef CONFIG_DWCS
+extern int DWCS_module_loaded;
+#endif
+
 /*
  * Timekeeping variables
  */
@@ -63,6 +69,12 @@
 
 unsigned long event;
 
+#ifdef DWCS_DEBUG_ON
+unsigned long dwcs_timer_max_time = 0;
+unsigned long dwcs_timer_old_time = 0;
+long dwcs_max_counter = 0;
+#endif
+
 extern int do_setitimer(int, struct itimerval *, struct itimerval *);
 
 unsigned long volatile jiffies;
@@ -597,8 +609,27 @@
 	struct task_struct *p = current;
 	int cpu = smp_processor_id(), system = user_tick ^ 1;
 
+#ifdef DWCS_DEBUG_ON
+	if (dwcs_timer_old_time == 0) {
+		dwcs_timer_old_time = jiffies;
+	} else {
+		unsigned long tmp;
+		tmp = jiffies - dwcs_timer_old_time;
+		dwcs_timer_old_time = jiffies;
+		if (dwcs_timer_max_time < tmp) {
+			dwcs_timer_max_time = tmp;
+		}
+	}
+#endif
+
 	update_one_process(p, user_tick, system, cpu);
-	if (p->pid) {
+	//if (p->pid) {
+	if (1) {
+#ifdef DWCS_DEBUG_ON
+		if (p->counter > dwcs_max_counter) {
+			dwcs_max_counter = p->counter;
+		}
+#endif
 		if (--p->counter <= 0) {
 			p->counter = 0;
 			p->need_resched = 1;
@@ -695,6 +726,11 @@
 
 	update_process_times(user_mode(regs));
 #endif
+#ifdef CONFIG_DWCS
+	if (DWCS_module_loaded == 1) {
+	  	current->need_resched = 1;
+	}
+#endif
 	mark_bh(TIMER_BH);
 	if (TQ_ACTIVE(tq_timer))
 		mark_bh(TQUEUE_BH);
